#ifndef DEF_INC
#define DEF_INC

#define BIN_DIR "/usr/bin"
#define KATRIN_LIB_DIR "/usr/lib/katrin"

#define TYPE_LENGTH    10
#define SERVICE_NAME_LENGTH 15

#define MAX_PASSWORD_LENGTH 20
#define MAX_NUMBER_OF_PARAMS 10
#define MAX_PARAM_NAME_LENGTH 15
#define MAX_PARAM_VALUE_LENGTH 1900

#include <stdlib.h>
#include <string.h>

enum accountType { Personal = 1, Group = 2 };
enum accountState { Blocked = 1, Activated = 0 };
enum abonentType { Client = 1, ClientGroup = 2 };

struct tariff {
	int id;
	char week_days[20];
};

struct service {
	char name[SERVICE_NAME_LENGTH];
};

struct account {
	int id;
	double balance;
	double credit;
	enum accountState blocked;
	enum accountType type;
	int client_id;
	int group_id;
};


struct paramlist {
	char param[MAX_PARAM_NAME_LENGTH];
	char value[MAX_PARAM_VALUE_LENGTH];
	struct paramlist *next;
};

struct serviceslist {
	struct service service;
	struct tariff tariff;
	struct account account;
	struct serviceslist *next;
};

struct client {
	int id;
	char password[MAX_PASSWORD_LENGTH];
	struct paramlist *uparams;
	struct serviceslist *services;
};

struct clientslist {
	struct clientslist *next;
	struct client *client;
};

struct clientgroup {
	int id;
	struct clientslist *members;
	struct paramlist *gparams;
};

union abonent {
	struct client client;
	struct clientgroup clientgroup;
};

struct abonentslist {
	enum abonentType type;
	union abonent *abonent;
	struct service service;
	struct abonentslist *next;
};

struct filter {
	int id;
	int tariffid;
	int priority;
	int store_stat;
	struct paramlist *params;
};

struct filterslist {
	struct filterslist *next;
	struct filter filter;
};

struct service_info {
		char type[TYPE_LENGTH];
	int len;
};

struct client_service_info {
	int client_id;
	int account_id;
	int filterid;
	double cost;
};

#endif


